"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _color = _interopRequireDefault(require("../Util/color.json"));

var _Box = _interopRequireDefault(require("../Box"));

var _Press = _interopRequireDefault(require("../Press"));

var _Toast = _interopRequireDefault(require("../Toast"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _Util = require("../Util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ViewWidthDesign = 375;
const ViewHeightDesign = 375; // 旋转90度

const transformComponents = (width, ChildrenComponent) => {
  const translateX = (ViewHeightDesign - width) / 2;
  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    w: width,
    h: ViewHeightDesign
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    flex: 1,
    style: {
      transform: [{
        rotate: "90deg"
      }]
    }
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    col: true,
    bg: "B020",
    w: ViewHeightDesign,
    h: width,
    style: {
      transform: [{
        translateX: -(0, _Util.getSize)(translateX)
      }]
    }
  }, ChildrenComponent)));
}; // 弹窗动画展示时间


const startAnimation = 10;
const hideAnimation = 10;

const ActionSheet = _ref => {
  let {
    visible,
    headerTitle = "",
    showHeaderCloseIcon = true,
    content,
    footer = "确认",
    headerRightText = "",
    contentPadding = 16,
    contentMinHeight = 166,
    showFooter = true,
    showStartAnimation = true,
    showHideAnimation = true,
    onHeaderRightClick,
    onCloseIconClick,
    onRequestClose,
    onFooterClick,
    bounces = true,
    msgData = {
      msg: "",
      type: 0,
      timestamp: 0
    },
    isLandscape = false,
    persistTaps = "handled"
  } = _ref;
  const theme = "day";
  const bgColor = _color.default.B020[theme];
  const activeAnim = (0, _react.useRef)(new _reactNativeWeb.Animated.Value(0)).current;
  const opacityAnim = (0, _react.useRef)(new _reactNativeWeb.Animated.Value(0)).current;
  const [_visible, _setVisible] = (0, _react.useState)(visible);
  (0, _react.useEffect)(() => {
    let _hideAnimation = hideAnimation;
    let _startAnimation = startAnimation;

    if (!showHideAnimation) {
      _hideAnimation = 0;
    }

    if (!showStartAnimation) {
      _startAnimation = 0;
    }

    visible && _setVisible(true);

    _reactNativeWeb.Animated.parallel([_reactNativeWeb.Animated.timing(opacityAnim, {
      toValue: visible ? 1 : 0,
      duration: visible ? _startAnimation : _hideAnimation,
      useNativeDriver: false
    }), _reactNativeWeb.Animated.timing(activeAnim, {
      toValue: visible ? 0 : 200,
      duration: visible ? _startAnimation : _hideAnimation,
      useNativeDriver: false
    })]).start(() => visible || _setVisible(false));
  }, [visible, _setVisible]);

  const _body = /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Animated.View, {
    style: [styles.modalView, {
      transform: [{
        translateY: activeAnim
      }],
      backgroundColor: bgColor
    }]
  }, !!headerTitle && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    h: 56
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    c: true,
    flex: 1,
    f: 18,
    cl: "T010",
    fw: "500"
  }, headerTitle), showHeaderCloseIcon && /*#__PURE__*/_react.default.createElement(_Press.default, {
    ab: true,
    f: 14,
    l: 16,
    onPress: onCloseIconClick || onFooterClick
  }, /*#__PURE__*/_react.default.createElement(_Icon.default, {
    type: "icon_m_close",
    w: 18,
    h: 18
  })), !!headerRightText && /*#__PURE__*/_react.default.createElement(_Press.default, {
    ab: true,
    r: 16,
    onPress: onHeaderRightClick
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    f: 14,
    cl: "Blu010"
  }, headerRightText))), /*#__PURE__*/_react.default.createElement(_Box.default, {
    h: 1,
    bg: "B010"
  })), /*#__PURE__*/_react.default.createElement(_reactNativeWeb.SafeAreaView, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    p: contentPadding,
    style: {
      alignItems: "flex-start"
    }
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.ScrollView, {
    style: {
      minHeight: contentMinHeight,
      maxHeight: isLandscape ? 319 : 400
    },
    showsVerticalScrollIndicator: false,
    bounces: bounces,
    keyboardShouldPersistTaps: persistTaps
  }, content)), !isLandscape && showFooter && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    h: 6,
    bg: "B010"
  }), /*#__PURE__*/_react.default.createElement(_Box.default, {
    h: 56
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.TouchableOpacity, {
    style: {
      flex: 1
    },
    onPress: onFooterClick,
    activeOpacity: 0.8
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    c: true,
    flex: 1,
    f: 18,
    cl: "T010",
    fw: "500"
  }, footer))))));

  return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Modal, {
    transparent: true,
    visible: _visible,
    onRequestClose: onRequestClose || onCloseIconClick || onFooterClick
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Animated.View, {
    style: [styles.container, {
      opacity: opacityAnim
    }]
  }, /*#__PURE__*/_react.default.createElement(_Toast.default, {
    msg: msgData.msg,
    type: msgData.type,
    timestamp: msgData.timestamp
  }), isLandscape ? transformComponents(ViewWidthDesign, _body) : _body));
};

const styles = _reactNativeWeb.StyleSheet.create({
  container: {
    display: "flex",
    alignItems: "center",
    justifyContent: "flex-end",
    backgroundColor: "rgba(0, 0, 0, .3)",
    flex: 1
  },
  modalView: {
    borderTopEndRadius: 8,
    borderTopStartRadius: 8,
    maxWidth: _reactNativeWeb.Platform.OS === "web" ? 700 : "100%",
    width: "100%",
    display: "flex",
    flexDirection: "column"
  }
});

var _default = ActionSheet;
exports.default = _default;