"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _Box = _interopRequireDefault(require("../Box"));

var _color = require("../Util/color.json");

var _style = require("./style");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/**
 * Badge组件
 */
function Badge(_ref) {
  let {
    children,
    bg = 'Org010',
    cl = 'T060',
    count,
    overflowCount = 99,
    offset = [0, 0],
    showZero = false
  } = _ref;
  const isNumber = typeof count === 'number';
  const numberedDisplayedCount = Number(count) > Number(overflowCount) ? "".concat(Number(overflowCount), "+") : count;
  const {
    length
  } = "".concat(numberedDisplayedCount);
  const type = length === 1 ? 'single' : 'multiple';
  const BadgeContent = isNumber ? /*#__PURE__*/_react.default.createElement(_Box.default, _extends({}, _objectSpread(_objectSpread({}, _style.Styles[type]), {}, {
    bg,
    cl
  }), {
    DIN: true
  }), numberedDisplayedCount) : /*#__PURE__*/_react.default.createElement(_Box.default, _objectSpread(_objectSpread({}, _style.Styles[type]), {}, {
    bg,
    cl
  }), numberedDisplayedCount);
  return children ? /*#__PURE__*/_react.default.createElement(_Box.default, null, children, /*#__PURE__*/_react.default.createElement(_Box.default, {
    t: -6,
    r: isNumber ? -(5 * length + 8) / 2 : -(9 * length + 8) / 2,
    ab: true,
    mt: -offset[1],
    mr: -offset[0]
  }, (count || showZero) && BadgeContent)) : /*#__PURE__*/_react.default.createElement(_Box.default, null, (count || showZero) && BadgeContent);
}

var _default = Badge;
exports.default = _default;