"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es.object.assign.js");

var _react = _interopRequireDefault(require("react"));

var _reactNativeWeb = require("react-native-web");

var _props = require("../Util/props");

var _Util = require("../Util");

var _Txt = _interopRequireDefault(require("../Txt"));

const _excluded = ["style", "children", "noAuto"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const Box = _ref => {
  let {
    style,
    children,
    noAuto = false
  } = _ref,
      props = _objectWithoutProperties(_ref, _excluded);

  const newProps = _objectSpread({}, props); // 默认横向 flex 且 垂直居中


  let boxStylesObj = {
    flexDirection: 'row',
    alignItems: 'center'
  };
  const OtherProps = {};
  const childType = typeof children;
  const isText = ['boolean', 'string', 'number'].indexOf(childType) > -1; // 通用样式赋值

  Object.keys(newProps).map(item => {
    // 尺寸类 屏幕适配
    if (!noAuto && _props.sizeProps.indexOf(item) > -1 && typeof newProps[item] === 'number') {
      newProps[item] = (0, _Util.getSize)(newProps[item]);
    }

    if (item in _props.boxProps) {
      // box颜色处理 bg backgroundColor  bc borderColor
      if (['bg', 'bc'].indexOf(item) > -1 && props[item] && props[item].indexOf('#') === -1) {
        boxStylesObj[_props.boxProps[item].property] = _Util.ThemeColor[props[item]] && _Util.ThemeColor[props[item]][_Util.THEME] || 'white';
        return '';
      } // center 等值的处理


      if (_props.boxProps[item].value && props[item]) {
        boxStylesObj = Object.assign(boxStylesObj, _props.boxProps[item].value);
        return '';
      }

      boxStylesObj[_props.boxProps[item].property] = newProps[item];
    }

    OtherProps[item] = props[item];
    return '';
  });

  const boxStyle = _reactNativeWeb.StyleSheet.create({
    box: boxStylesObj
  });

  if (isText) {
    return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
      style: [boxStyle.box, style]
    }, /*#__PURE__*/_react.default.createElement(_Txt.default, _extends({
      style: style,
      noAuto: noAuto
    }, OtherProps), children));
  }

  return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, _extends({
    style: [boxStyle.box, style]
  }, OtherProps), children);
};

var _default = Box;
exports.default = _default;