"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _reactNativeWeb = require("react-native-web");

var _Util = require("../Util");

var _Box = _interopRequireDefault(require("../Box"));

const _excluded = ["children", "onPress", "size", "type", "disabled", "ab", "l", "r", "t", "b", "m", "mx", "my", "ml", "mr", "mt", "mb", "disabledClick"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

const Button = props => {
  const {
    children,
    onPress,
    size = 'l',
    type = 'primary',
    disabled,
    ab,
    l,
    r,
    t,
    b,
    m,
    mx,
    my,
    ml,
    mr,
    mt,
    mb,
    disabledClick = true
  } = props,
        otherProps = _objectWithoutProperties(props, _excluded);

  const colorType = disabled ? "".concat(type, "Dis") : type;
  const gts = _Util.getSize;
  const marginList = {
    // margin系列加外层
    margin: m,
    marginHorizontal: mx,
    marginVertical: my,
    marginLeft: ml,
    marginRight: mr,
    marginTop: mt,
    marginBottom: mb
  };
  const boxSize = {
    l: {
      // 大
      px: 0,
      h: 44,
      f: 16
    },
    m: {
      // 中
      px: 12,
      h: 28,
      f: 14
    },
    s: {
      // 小
      px: 8,
      h: 24,
      f: 12
    }
  };
  const boxColor = {
    primary: {
      bg: 'Blu010',
      // 背景色
      cl: 'T060' // 文字色

    },
    primaryDis: {
      bg: 'Blu014',
      cl: 'TBlu016'
    },
    secondary: {
      bg: 'Blu015',
      cl: 'TBlu017'
    },
    secondaryDis: {
      bg: 'Blu016',
      cl: 'TBlu018'
    },
    white: {
      bg: 'B020',
      cl: 'TBlu017'
    },
    whiteDis: {
      bg: 'B020',
      cl: 'TBlu018'
    }
  };
  return ab ? /*#__PURE__*/_react.default.createElement(_Box.default, {
    ab: true,
    l: l,
    r: r,
    t: t,
    b: b,
    w: size === 'l' ? '100%' : undefined
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.TouchableOpacity, {
    style: size === 'l' ? _objectSpread({
      flex: 1,
      flexDirection: 'row'
    }, marginList) : _objectSpread({
      minWidth: size === 'm' ? gts(66) : gts(52),
      height: gts(boxSize[size].h)
    }, marginList),
    onPress: onPress,
    disabled: disabled && disabledClick,
    activeOpacity: 0.8,
    hitSlop: {
      left: 8,
      right: 8,
      top: 8,
      bottom: 8
    }
  }, /*#__PURE__*/_react.default.createElement(_Box.default, _extends({
    flex: 1,
    br: 100,
    c: true
  }, boxSize[size], boxColor[colorType], otherProps), children))) :
  /*#__PURE__*/
  // 大按钮宽度默认撑满，中小按钮宽度由内容撑开
  _react.default.createElement(_reactNativeWeb.TouchableOpacity, {
    style: size === 'l' ? _objectSpread({
      flex: 1,
      flexDirection: 'row'
    }, marginList) : _objectSpread({
      minWidth: size === 'm' ? gts(66) : gts(52),
      height: gts(boxSize[size].h)
    }, marginList),
    onPress: onPress,
    disabled: disabled && disabledClick,
    activeOpacity: 0.8,
    hitSlop: {
      left: 8,
      right: 8,
      top: 8,
      bottom: 8
    }
  }, /*#__PURE__*/_react.default.createElement(_Box.default, _extends({
    flex: 1,
    br: 100,
    c: true
  }, boxSize[size], boxColor[colorType], otherProps), children));
};

var _default = Button;
exports.default = _default;