"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _Box = _interopRequireDefault(require("../Box"));

var _Press = _interopRequireDefault(require("../Press"));

var _Icon = _interopRequireDefault(require("../Icon"));

var _ActionSheet = _interopRequireDefault(require("../ActionSheet"));

const _excluded = ["children", "title", "assisText", "actionsheetTitle", "actionsheetContent", "jumpUrl", "jumpUrlText"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function Card(_ref) {
  let {
    children,
    title = "",
    assisText = "",
    actionsheetTitle = "",
    actionsheetContent,
    jumpUrl,
    jumpUrlText = ""
  } = _ref,
      boxProps = _objectWithoutProperties(_ref, _excluded);

  const theme = "day";
  const [visible, setVisible] = (0, _react.useState)(false);
  return /*#__PURE__*/_react.default.createElement(_Box.default, _extends({
    w: "100%",
    bg: "B020",
    px: 12,
    pt: 12,
    pb: 12,
    mt: 8,
    mx: 12,
    br: 8
  }, boxProps, {
    col: true,
    flex: 1
  }), /*#__PURE__*/_react.default.createElement(_Box.default, {
    col: true,
    pb: assisText ? 4 : 12
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    style: {
      justifyContent: "space-between"
    }
  }, /*#__PURE__*/_react.default.createElement(_Box.default, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    cl: "T010",
    fw: "500",
    f: 16,
    lh: 22
  }, title), actionsheetContent && /*#__PURE__*/_react.default.createElement(_Press.default, {
    ml: 3,
    onPress: () => {
      setVisible(true);
    }
  }, /*#__PURE__*/_react.default.createElement(_Icon.default, {
    type: "icon_s_explain_linear"
  }))), jumpUrlText ? /*#__PURE__*/_react.default.createElement(_Press.default, {
    onPress: () => {}
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    f: 12,
    lh: 16,
    cl: "T020"
  }, jumpUrlText), jumpUrl ? /*#__PURE__*/_react.default.createElement(_Icon.default, {
    type: "icon_s_more"
  }) : null) : null), assisText ? /*#__PURE__*/_react.default.createElement(_Box.default, {
    mt: 2,
    f: 12,
    cl: "T030"
  }, assisText) : null), children, actionsheetContent ? /*#__PURE__*/_react.default.createElement(_ActionSheet.default, {
    showHeaderCloseIcon: true,
    footer: "\u6211\u77E5\u9053\u4E86",
    visible: visible,
    onRequestClose: () => {
      setVisible(false);
    },
    onCloseIconClick: () => {
      setVisible(false);
    },
    onFooterClick: () => {
      setVisible(false);
    },
    content: actionsheetContent,
    headerTitle: actionsheetTitle
  }) : null);
}

var _default = Card;
exports.default = _default;