"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

require("core-js/modules/es.parse-float.js");

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _Box = _interopRequireDefault(require("../Box"));

var _Util = require("../Util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

const defaultColors = [["Red010", "Grn010"], ["L010", "L010"]];
/**
 * 对比条组件
 */

const WinRate = props => {
  const {
    fields = [],
    data = [],
    colors = [],
    width = 140,
    itemHeight,
    itemInterval = 12,
    itemBarHeight = 4,
    itemBarInterval = 2
  } = props;
  const real_itemHeight = itemHeight || fields.length * itemBarHeight + itemBarInterval * (fields.length - 1);
  const [maxLength, setMaxLength] = (0, _react.useState)(1);
  const [rateType, setRateType] = (0, _react.useState)("left");
  (0, _react.useEffect)(() => {
    let _rateType = "left";
    let left = 0;
    let right = 0;
    const all_rate = [];
    data.forEach(item => {
      fields.forEach(field_item => {
        const value = parseFloat(String(item[field_item])) || 0;
        all_rate.push(value);
        if (value > 0) right += 1;
        if (value < 0) left += 1;
      });
    });
    if (left !== 0 && right !== 0) _rateType = "middle";else if (left === 0 && right > 0) _rateType = "left";else if (left > 0 && right === 0) _rateType = "right";
    const maxlength = Math.max(...all_rate.map(e => Math.abs(e))) || 1;
    setMaxLength(maxlength);
    setRateType(_rateType);
  }, [data, fields]);
  const line_position = rateType === "middle" ? {
    l: "50%"
  } : rateType === "right" ? {
    r: 0
  } : {
    l: 0
  };

  const computedRatio = value => Math.abs(value / maxLength * (rateType === "middle" ? width / 2 : width));

  return /*#__PURE__*/_react.default.createElement(_Box.default, {
    col: true,
    c: true,
    w: width
  }, /*#__PURE__*/_react.default.createElement(_Box.default, _extends({
    ab: true,
    w: 0.5,
    h: real_itemHeight * data.length + itemInterval * (data.length - 1),
    bg: "L010"
  }, line_position)), data.map((item, index) => /*#__PURE__*/_react.default.createElement(_Box.default, {
    col: true,
    c: true,
    mt: index !== 0 ? itemInterval : 0,
    h: real_itemHeight
  }, fields.map((field_item, field_index) => {
    const value = item[field_item] || "";

    const _color = colors[field_index] || defaultColors[field_index] || defaultColors[defaultColors.length - 1];

    const left_color = _color[1] || "L010";
    const right_color = _color[0] || "L010";
    return /*#__PURE__*/_react.default.createElement(_Box.default, {
      w: width,
      mt: field_index !== 0 ? itemBarInterval : 0
    }, value && value < 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
      flex: 1
    }), /*#__PURE__*/_react.default.createElement(_Box.default, {
      w: computedRatio(value),
      bg: left_color,
      h: itemBarHeight,
      style: styles.borderRadiusLeft
    })) : /*#__PURE__*/_react.default.createElement(_Box.default, {
      w: rateType === "middle" ? width / 2 : 0,
      h: itemBarHeight
    }), value && value > 0 ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
      w: computedRatio(value),
      bg: right_color,
      h: itemBarHeight,
      style: styles.borderRadiusRight
    }), /*#__PURE__*/_react.default.createElement(_Box.default, {
      flex: 1
    })) : /*#__PURE__*/_react.default.createElement(_Box.default, {
      w: rateType === "middle" ? width / 2 : 0,
      h: itemBarHeight
    }));
  }))));
};

var _default = WinRate;
exports.default = _default;

const styles = _reactNativeWeb.StyleSheet.create({
  borderRadiusLeft: {
    borderTopLeftRadius: (0, _Util.getSize)(4),
    borderTopRightRadius: 0,
    borderBottomRightRadius: 0,
    borderBottomLeftRadius: (0, _Util.getSize)(4)
  },
  borderRadiusRight: {
    borderTopLeftRadius: 0,
    borderTopRightRadius: (0, _Util.getSize)(4),
    borderBottomRightRadius: (0, _Util.getSize)(4),
    borderBottomLeftRadius: 0
  }
});