"use strict";

require("core-js/modules/es.object.assign.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _Util = require("../Util");

const _excluded = ["w", "h", "style", "source", "autoContainImage", "resizeMode"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * 网络图片
 */
function Img(_ref) {
  let {
    w,
    h,
    style,
    source,
    autoContainImage = false,
    resizeMode
  } = _ref,
      props = _objectWithoutProperties(_ref, _excluded);

  const {
    uri: url = ""
  } = source;
  const [size, setSize] = (0, _react.useState)({
    w: 0,
    h: 0
  });
  const [_resizeMode, setResizeMode] = (0, _react.useState)("cover");
  (0, _react.useEffect)(() => {
    let tempSize = {
      w,
      h
    };

    _reactNativeWeb.Image.getSize(url, (width, height) => {
      if (w && h && autoContainImage && !resizeMode) {
        (height / width > 1.5 * h / w || width / height > 1.5 * w / h) && setResizeMode("contain");
      } else if (!h && w) {
        tempSize = {
          h: height / width * w,
          w
        };
      } else if (h && !w) {
        tempSize = {
          w: width / height * h,
          h
        };
      } else if (!h && !w) {
        tempSize = {
          w: width,
          h: height
        };
      }

      setSize(tempSize);
    });
  }, [url, w, h]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Image, _extends({}, props, {
    resizeMode: resizeMode || _resizeMode,
    source: {
      uri: url
    },
    style: [{
      width: (0, _Util.getSize)(size.w),
      height: (0, _Util.getSize)(size.h)
    }, style]
  }));
}

var _default = Img;
exports.default = _default;