"use strict";

require("core-js/modules/web.dom-collections.iterator.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _color = _interopRequireDefault(require("../Util/color.json"));

var _XqText = _interopRequireDefault(require("../XqText"));

var _Box = _interopRequireDefault(require("../Box"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const XqModal = _ref => {
  let {
    visible,
    modalTitle,
    modalDesc,
    cancelText = "取消",
    onCancel,
    onOk,
    okText = onCancel ? "确认" : "我知道了"
  } = _ref;
  const theme = "day";
  return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
    style: styles.centeredView
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Modal, {
    animationType: "fade",
    transparent: true,
    visible: visible
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
    style: styles.centeredView
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
    style: [styles.modalView, {
      backgroundColor: _color.default.B030[theme]
    }]
  }, !!modalTitle && /*#__PURE__*/_react.default.createElement(_XqText.default, {
    size: 16,
    level: 1,
    style: styles.modalTitle
  }, modalTitle), /*#__PURE__*/_react.default.createElement(_XqText.default, {
    size: 15,
    level: 2,
    style: styles.modalDesc
  }, modalDesc), /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
    style: [styles.footer, {
      borderColor: _color.default.L010[theme]
    }]
  }, onCancel ? /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_Box.default, {
    style: [styles.textStyle, {
      color: _color.default.T020[theme]
    }],
    onPress: onCancel
  }, cancelText), /*#__PURE__*/_react.default.createElement(_reactNativeWeb.View, {
    style: [styles.divider, {
      backgroundColor: _color.default.L010[theme]
    }]
  }), /*#__PURE__*/_react.default.createElement(_Box.default, {
    style: styles.textStyle,
    onPress: onOk
  }, okText)) : /*#__PURE__*/_react.default.createElement(_Box.default, {
    style: [styles.textStyle, {
      width: "100%"
    }],
    onPress: onOk
  }, okText))))));
};

const styles = _reactNativeWeb.StyleSheet.create({
  centeredView: {
    flex: 1,
    justifyContent: "center",
    alignItems: "center",
    backgroundColor: "rgba(0,0,0,.5)"
  },
  modalView: {
    margin: 20,
    backgroundColor: "white",
    borderRadius: 12,
    paddingTop: 30,
    width: 280,
    alignItems: "center",
    shadowColor: "#000",
    shadowOffset: {
      width: 0,
      height: 2
    },
    elevation: 5
  },
  footer: {
    display: "flex",
    flexDirection: "row",
    width: "100%",
    height: 50,
    borderTopWidth: 0.5,
    borderColor: "#E8E8E8"
  },
  divider: {
    height: 18,
    width: 0.5,
    marginVertical: 16
  },
  // openButton: {
  //   flex: 1,
  //   width: '50%',
  //   elevation: 2,
  // },
  textStyle: {
    flex: 1,
    color: "#3B7EEE",
    textAlign: "center",
    // width: '50%',
    fontSize: 16,
    lineHeight: 50
  },
  modalTitle: {
    marginBottom: 12,
    fontSize: 18,
    fontWeight: "500",
    textAlign: "center"
  },
  modalDesc: {
    marginBottom: 14,
    fontSize: 15,
    textAlign: "left",
    lineHeight: 22,
    paddingHorizontal: 14
  }
});

var _default = XqModal;
exports.default = _default;