"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _Box = _interopRequireDefault(require("../Box"));

var _Image = _interopRequireDefault(require("../Image"));

var _Press = _interopRequireDefault(require("../Press"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const ZOOM_PARAMETER = 0.5;
const startAnimation = 10;
const hideAnimation = 10;
const CLOSE_ICON = {
  day: "https://xqimg.imedao.com/1815fe763fbc5883fcaf2dbe.png",
  night: "https://xqimg.imedao.com/1815fe7668ec5893fdef3ac3.png"
};
const THEME = "day";

const PopupBase = _ref => {
  let {
    visible,
    children,
    showCloseIcon = true,
    onClose,
    w = 280,
    h = 378,
    showStartAnimation = true,
    showHideAnimation = false
  } = _ref;
  const [_visible, _setVisible] = (0, _react.useState)(visible);
  const zoomAnim = (0, _react.useRef)(new _reactNativeWeb.Animated.Value(ZOOM_PARAMETER)).current;
  const opacityAnim = (0, _react.useRef)(new _reactNativeWeb.Animated.Value(0)).current;
  (0, _react.useEffect)(() => {
    let _hideAnimation = hideAnimation;
    let _startAnimation = startAnimation;

    if (!showHideAnimation) {
      _hideAnimation = 0;
    }

    if (!showStartAnimation) {
      _startAnimation = 0;
    }

    visible && _setVisible(true);

    _reactNativeWeb.Animated.parallel([_reactNativeWeb.Animated.timing(zoomAnim, {
      toValue: visible ? 1 : ZOOM_PARAMETER,
      duration: visible ? _startAnimation : _hideAnimation,
      useNativeDriver: false
    }), _reactNativeWeb.Animated.timing(opacityAnim, {
      toValue: visible ? 1 : 0,
      duration: visible ? _startAnimation : _hideAnimation,
      useNativeDriver: false
    })]).start(() => visible || _setVisible(false));
  }, [visible, _setVisible]);
  return /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Modal, {
    visible: _visible,
    transparent: true,
    onRequestClose: onClose
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    h: "100%",
    w: "100%",
    c: true
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Animated.View, {
    style: [styles.maskView, {
      opacity: opacityAnim
    }]
  }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Animated.View, {
    style: [styles.container, {
      transform: [{
        scale: zoomAnim
      }],
      opacity: opacityAnim
    }]
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    w: w,
    h: h,
    br: 12,
    style: {
      overflow: "hidden"
    }
  }, children), showCloseIcon && /*#__PURE__*/_react.default.createElement(_Press.default, {
    onPress: onClose
  }, /*#__PURE__*/_react.default.createElement(_Box.default, {
    mt: 40
  }, /*#__PURE__*/_react.default.createElement(_Image.default, {
    source: {
      uri: CLOSE_ICON[THEME]
    },
    w: 32,
    h: 32
  })))))));
};

const styles = _reactNativeWeb.StyleSheet.create({
  maskView: {
    backgroundColor: "rgba(0, 0, 0, .3)",
    // position: 'absolute',
    width: "100%",
    height: "100%",
    display: "flex",
    alignItems: "center",
    justifyContent: "center"
  },
  container: {
    alignItems: "center",
    display: "flex",
    flexDirection: "column"
  }
});

var _default = PopupBase;
exports.default = _default;