"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = Toast;

require("core-js/modules/web.dom-collections.iterator.js");

var _react = _interopRequireWildcard(require("react"));

var _reactNativeWeb = require("react-native-web");

var _Box = _interopRequireDefault(require("../Box"));

var _Util = require("../Util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

const {
  width,
  height
} = _reactNativeWeb.Dimensions.get("window");

const style = function style() {
  let theme = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : "day";
  return _reactNativeWeb.StyleSheet.create({
    textContainer: {
      maxWidth: (0, _Util.getSize)(width * 0.8)
    },
    container: {
      zIndex: 1000
    },
    displayNone: {
      display: "none"
    }
  });
};

const uri = {
  1: "https://xqimg.imedao.com/1806500804394a93fe1e2ed6.png",
  2: "https://xqimg.imedao.com/180650081a596723fb733e2e.png"
};

function Toast(_ref) {
  let {
    msg = "",
    type = 0,
    timestamp = 0
  } = _ref;
  const theme = "day";
  const styles = style(theme);
  const [m, setM] = (0, _react.useState)("");
  const [t, setT] = (0, _react.useState)(0);
  const [ts, setTs] = (0, _react.useState)(0);
  const [show, setShow] = (0, _react.useState)(false);
  const [id, setId] = (0, _react.useState)(0);
  (0, _react.useEffect)(() => {
    if (msg !== "" && timestamp !== ts && timestamp !== 0) {
      clearTimeout(id);
      setM(msg);
      setT(type);
      setTs(timestamp);
      setShow(true);
      setId(setTimeout(() => {
        setShow(false);
      }, 2500)); // }
    }
  }, [msg, timestamp]);

  if (show) {
    return /*#__PURE__*/_react.default.createElement(_Box.default, {
      c: true,
      ab: true,
      t: -(height / 2 - 114),
      b: 0,
      style: styles.container
    }, /*#__PURE__*/_react.default.createElement(_Box.default, {
      c: true,
      py: 10,
      px: 20,
      br: 20,
      bg: t < 2 ? "Blu010" : "Red011",
      style: styles.textContainer
    }, /*#__PURE__*/_react.default.createElement(_Box.default, {
      mr: 6,
      style: t === 0 && styles.displayNone
    }, /*#__PURE__*/_react.default.createElement(_reactNativeWeb.Image, {
      source: {
        uri: uri[t]
      },
      style: {
        width: (0, _Util.getSize)(16),
        height: (0, _Util.getSize)(16)
      }
    })), /*#__PURE__*/_react.default.createElement(_Box.default, {
      f: 16,
      cl: t < 2 ? "T060" : "Red010"
    }, m)));
  }

  return null;
}

Toast.defaultProps = {
  msg: "",
  type: 0,
  timestamp: 0
};