"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ThemeColor = exports.THEME = void 0;
exports.formatCurrencyNormal = formatCurrencyNormal;
exports.getSize = exports.getPicSuffixUrl = exports.getPercentValues = exports.formatDate = void 0;

require("core-js/modules/es.number.to-fixed.js");

require("core-js/modules/es.regexp.exec.js");

require("core-js/modules/es.regexp.test.js");

require("core-js/modules/es.string.split.js");

var _numeral = _interopRequireDefault(require("numeral"));

var _color = _interopRequireDefault(require("./color.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const ThemeColor = _color.default; //export const DeviceWidth = Dimensions.get('window').width || 375;
//const isNodeEnv = typeof process !== 'undefined' && process && process.versions && process.versions.node;
//export const OS: 'ios' | 'android' | 'windows' | 'macos' | 'web' | 'node' = isNodeEnv ? 'node' : Platform.OS;
// eslint-disable-next-line import/no-mutable-exports

exports.ThemeColor = ThemeColor;
let THEME = 'day';
/**
 * rn & web 同构适配大小
 * 支持SSR服务端渲染
 * web使用 采用vw rem布局方案
 */

exports.THEME = THEME;

const getSize = px => {
  return "".concat(px / 14, "rem");
};

exports.getSize = getSize;

const getPercentValues = function getPercentValues() {
  let value = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
  let stColor = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1;
  const colors = ['Grn010', 'Red010'];
  const v = Number(value);
  const change = stColor !== -1;
  const values = {
    color: 'T020',
    symbol: '',
    value: '--',
    percent: ''
  };

  if (Number.isNaN(v)) {
    return _objectSpread(_objectSpread({}, values), {}, {
      value
    });
  }

  if (value !== null) {
    if (v > 0) {
      values.symbol = '+';
      values.color = change ? colors[stColor] : 'T010';
    } else if (v < 0) {
      values.symbol = '-';
      values.color = change ? colors[1 - stColor] : 'T010';
    }

    return _objectSpread(_objectSpread({}, values), {}, {
      value: "".concat(Math.abs(v * 100).toFixed(2)),
      percent: '%'
    });
  }

  return values;
};

exports.getPercentValues = getPercentValues;

function formatCurrencyNormal(num) {
  let {
    withPlus = false,
    withColor = false,
    stColor = 1
  } = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  const colors = stColor === 1 ? ['Grn010', 'Red010'] : ['Red010', 'Grn010'];
  let color = 'T010';

  if (num === '--' || num === undefined) {
    return {
      value: '--',
      color
    };
  }

  let numText = (0, _numeral.default)(num).format('0,0.00');

  if (Math.abs(num) >= 100000000) {
    numText = "".concat((0, _numeral.default)(num / 10000).format('0,0.00'), "\u4E07");
  }

  if (withPlus && num > 0) {
    numText = "+".concat(numText);
  }

  if (withColor && num) {
    color = num > 0 ? colors[1] : colors[0];
  }

  return {
    value: numText,
    color
  };
}

const getPicSuffixUrl = (url, suffix) => !/!/.test(url) ? "".concat(url).concat(suffix) : url; // 把 Date 对象转换为 ’YYYY-MM-DD' 格式


exports.getPicSuffixUrl = getPicSuffixUrl;

const formatDate = date => {
  let yourDate = date;
  const offset = yourDate.getTimezoneOffset();
  yourDate = new Date(yourDate.getTime() - offset * 60 * 1000);
  return yourDate.toISOString().split('T')[0];
};

exports.formatDate = formatDate;