"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.sizeProps = exports.fontProps = exports.colorJson = exports.boxProps = exports.PositionProps = void 0;

var _react = require("react");

var _color = _interopRequireDefault(require("./color.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const PositionProps = {
  ab: {
    value: {
      position: 'absolute'
    }
  },
  l: {
    property: 'left'
  },
  r: {
    property: 'right'
  },
  t: {
    property: 'top'
  },
  b: {
    property: 'bottom'
  },
  c: {
    value: {
      justifyContent: 'center'
    }
  },
  col: {
    value: {
      alignItems: 'stretch',
      flexDirection: 'column'
    }
  },
  flex: {
    property: 'flex'
  }
};
exports.PositionProps = PositionProps;
const colorJson = _color.default;
exports.colorJson = colorJson;
const fontProps = {
  f: {
    property: 'fontSize'
  },
  fw: {
    property: 'fontWeight'
  },
  cl: {
    property: 'color'
  },
  lh: {
    property: 'lineHeight'
  },
  DIN: {
    value: {
      fontFamily: 'DIN-Medium'
    }
  },
  ls: {
    property: 'letterSpacing'
  }
};
exports.fontProps = fontProps;
const sizeProps = ['l', 'r', 't', 'b', 'w', 'h', 'p', 'px', 'py', 'f', 'pl', 'pr', 'pt', 'pb', 'm', 'mx', 'my', 'mt', 'ml', 'mr', 'mb', 'br', 'bw', 'lh', 'ls'];
exports.sizeProps = sizeProps;

const boxProps = _objectSpread(_objectSpread({}, PositionProps), {}, {
  w: {
    property: 'width'
  },
  h: {
    property: 'height'
  },
  // style padding
  p: {
    property: 'padding'
  },
  px: {
    property: 'paddingHorizontal'
  },
  py: {
    property: 'paddingVertical'
  },
  pl: {
    property: 'paddingLeft'
  },
  pr: {
    property: 'paddingRight'
  },
  pt: {
    property: 'paddingTop'
  },
  pb: {
    property: 'paddingBottom'
  },
  // style margin
  m: {
    property: 'margin'
  },
  mx: {
    property: 'marginHorizontal'
  },
  my: {
    property: 'marginVertical'
  },
  ml: {
    property: 'marginLeft'
  },
  mr: {
    property: 'marginRight'
  },
  mt: {
    property: 'marginTop'
  },
  mb: {
    property: 'marginBottom'
  },
  // style backgroundColor
  bg: {
    property: 'backgroundColor'
  },
  // style border
  br: {
    property: 'borderRadius'
  },
  bw: {
    property: 'borderWidth'
  },
  bc: {
    property: 'borderColor'
  }
});

exports.boxProps = boxProps;